------------------------------------------------------------------------------------------
-- UI file
-- Written by Homeopatix
-- 26 january 2021
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- create the main window
------------------------------------------------------------------------------------------
function CreateMainWindow(widthWind, heightWind)
	OneToRuleThemAllWindow=Turbine.UI.Lotro.GoldWindow(); 
	OneToRuleThemAllWindow:SetSize(widthWind, heightWind); 
	OneToRuleThemAllWindow:SetText(Strings.PluginName); 
	OneToRuleThemAllWindow:SetZOrder(0);
	OneToRuleThemAllWindow:SetWantsKeyEvents(true);

	OneToRuleThemAllWindow.Message11=Turbine.UI.Label(); 
	OneToRuleThemAllWindow.Message11:SetParent(OneToRuleThemAllWindow); 
	OneToRuleThemAllWindow.Message11:SetSize(150,10); 
	OneToRuleThemAllWindow.Message11:SetPosition(OneToRuleThemAllWindow:GetWidth()/2 - 75, OneToRuleThemAllWindow:GetHeight() - 20); 
	OneToRuleThemAllWindow.Message11:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
	OneToRuleThemAllWindow.Message11:SetText(Strings.PluginText); 

	OneToRuleThemAllWindow:SetPosition((Turbine.UI.Display:GetWidth()-OneToRuleThemAllWindow:GetWidth())/2,(Turbine.UI.Display:GetHeight()-OneToRuleThemAllWindow:GetHeight())/2);

	------------------------------------------------------------------------------------------
	-- center window
	------------------------------------------------------------------------------------------
	positiony = 40;
	buttonVault = {};
	buttonVault2 = {};
	OneToRuleThemAllWindow.Message4 = {};
	OneToRuleThemAllWindow.Message5 = {};
	LabelIcon = {};
	LabelIcon2 = {};
	ButtonPlusLab = {};
	centerLabelBLab = {};
	
	if(settings["hasBeenChecked"]["value"] == false)then
		pluginToShow = 1;
	else
		pluginToShow = settings["nbrPlugins"]["nbr"];
	end

	if(settings["hasBeenChecked"]["value"] == false)then
		buttonChecked = Turbine.UI.Lotro.GoldButton();
		buttonChecked:SetParent( OneToRuleThemAllWindow );
		buttonChecked:SetPosition(OneToRuleThemAllWindow:GetWidth()/2 - 100, 90);
		buttonChecked:SetSize( 200, 30 );
		buttonChecked:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		buttonChecked:SetText( Strings.ButtonChecked );
		buttonChecked:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
		buttonChecked:SetVisible(true);
		buttonChecked:SetMouseVisible(true);
	end

	buttonChecked.MouseClick = function(sender, args)
		for i=1, settings["nbrPlugins"]["nbr"] do
			if(settings["pluginsToLoad"]["toBeLoaded" .. i] == false)then
				Turbine.PluginManager.UnloadScriptState(tostring(MyPlugins[i]));
				settings["pluginsToLoad"]["toBeLoaded" .. i] = false;
			else
				Turbine.PluginManager.LoadPlugin(tostring(MyPlugins[i]));
				settings["pluginsToLoad"]["toBeLoaded" .. i] = true;
			end
		end
		SaveSettings();
		OneToRuleThemAllWindow:SetVisible(false);
		settings["hasBeenChecked"]["value"] = true;
		UpdateMainWindow();
	end

	MyPlugins = {"OneToRuleThemAll",
				 "Animalerie",
				 "YulHelper", 
				 "YulTheatre",
				 "Farmer",
				 "Caserne",
				 "Fisherman",
				 "HorseStable",
				 "MinstrelMentor",
				 "Passage",
				 "PetStable",
				 "Escarmouche",
				 "FoodAndDrinks",
				 "PopoHelper",
				 "Profession",
				 "Voyage",
				 "AltHolic",
				 "BurglarHelper",
				 "Clock",
				 "EmotesHelper",
				 "ClassObjects",
				 "Potions",
				 "PlopIamConnected",
				 "DataDisplayer",
				 "ColorTester",
				 "Chronometre",
				 "FarmerParchemin"
				 };

	MyAdresse = {"http://www.lotrointerface.com/downloads/info1127",
				"http://www.lotrointerface.com/downloads/info1108", -- animalerie
				"http://www.lotrointerface.com/downloads/info1109", -- Yul helper
				"http://www.lotrointerface.com/downloads/info1110", -- Yul theatre
				"http://www.lotrointerface.com/downloads/info1112", -- farmer
				"http://www.lotrointerface.com/downloads/info1114", -- Caserne
				"http://www.lotrointerface.com/downloads/info1115", -- Fisherman
				"http://www.lotrointerface.com/downloads/info1116", -- HorseStable
				"http://www.lotrointerface.com/downloads/info1117", -- MinstrelMentor
				"http://www.lotrointerface.com/downloads/info1118", -- Passage
				"http://www.lotrointerface.com/downloads/info1119", -- PetStable
				"http://www.lotrointerface.com/downloads/info1120", -- Escarmouche
				"http://www.lotrointerface.com/downloads/info1121", -- FoodAndDrinks
				"http://www.lotrointerface.com/downloads/info1122", -- Popohelper
				"http://www.lotrointerface.com/downloads/info1123", -- Profession
				"http://www.lotrointerface.com/downloads/info1125", -- Voyage
				"http://www.lotrointerface.com/downloads/info1126", -- AltHolic
				"http://www.lotrointerface.com/downloads/info1127", -- BurglarHelper
				"http://www.lotrointerface.com/downloads/info1130", -- clock
				"http://www.lotrointerface.com/downloads/info1131", -- Emoteshelper
				"http://www.lotrointerface.com/downloads/info1132", -- ClassObjects
				"http://www.lotrointerface.com/downloads/info1133", -- Potions
				"http://www.lotrointerface.com/downloads/info1136", -- plopiamconnected
				"DataDisplayer",
				"ColorTester",
				 "Chronometre",
				 "FarmerParchemin"
				 };

	descr = {Strings.Description1,
				 Strings.Description2,
				 Strings.Description3, 
				 Strings.Description4,
				 Strings.Description5,
				 Strings.Description6,
				 Strings.Description7,
				 Strings.Description8,
				 Strings.Description9,
				 Strings.Description10,
				 Strings.Description11,
				 Strings.Description12,
				 Strings.Description13,
				 Strings.Description14,
				 Strings.Description15,
				 Strings.Description16,
				 Strings.Description17,
				 Strings.Description18,
				 Strings.Description19,
				 Strings.Description20,
				 Strings.Description21,
				 Strings.Description22,
				 Strings.Description23,
				 "DataDisplayer",
				 "ColorTester",
				 "Chronometre",
				 "FarmerParchemin"
				 };

	for i = 1, pluginToShow do
		IsLoaded = false;
		IsInstalled = false;
		PluginVersion = 0

		local tmpPlugins=Turbine.PluginManager.GetAvailablePlugins();
		local pluginIndex;
		for pluginIndex=1,#tmpPlugins do
			if (tmpPlugins[pluginIndex].Name == MyPlugins[i]) then
				IsInstalled = true;
				PluginVersion = tmpPlugins[pluginIndex].Version
				break;
			end
		end

		local tmpPlugins=Turbine.PluginManager.GetLoadedPlugins();
		local pluginIndex;
		for pluginIndex=1,#tmpPlugins do
			if (tmpPlugins[pluginIndex].Name == MyPlugins[i]) then
				IsLoaded = true;
				break;
			end
		end

		OneToRuleThemAllWindow.Message4[i]=Turbine.UI.Label(); 
		OneToRuleThemAllWindow.Message4[i]:SetParent(OneToRuleThemAllWindow); 
		OneToRuleThemAllWindow.Message4[i]:SetSize(190,32); 
		OneToRuleThemAllWindow.Message4[i]:SetPosition(56, positiony); 
		OneToRuleThemAllWindow.Message4[i]:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19);
		OneToRuleThemAllWindow.Message4[i]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
		OneToRuleThemAllWindow.Message4[i]:SetForeColor(Turbine.UI.Color.White);
		OneToRuleThemAllWindow.Message4[i]:SetMouseVisible(true);

		LabelIcon[i]=Turbine.UI.Label(); 
		LabelIcon[i]:SetParent(OneToRuleThemAllWindow); 
		LabelIcon[i]:SetSize(32, 32); 
		LabelIcon[i]:SetPosition(20, positiony); 
		LabelIcon[i]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
		LabelIcon[i]:SetZOrder(-1);
		LabelIcon[i]:SetBackground("Homeopatix/OneToRuleThemAll/Resources/Icones/" .. MyPlugins[i] .. ".tga");

		OneToRuleThemAllWindow.Message5[i]=Turbine.UI.Label(); 
		OneToRuleThemAllWindow.Message5[i]:SetParent(OneToRuleThemAllWindow); 
		OneToRuleThemAllWindow.Message5[i]:SetSize(170,30); 
		OneToRuleThemAllWindow.Message5[i]:SetPosition(70, positiony); 
		OneToRuleThemAllWindow.Message5[i]:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18);
		OneToRuleThemAllWindow.Message5[i]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight); 
		OneToRuleThemAllWindow.Message5[i]:SetForeColor(Turbine.UI.Color.White);

		LabelIcon2[i]=Turbine.UI.Label(); 
		LabelIcon2[i]:SetParent(OneToRuleThemAllWindow); 
		LabelIcon2[i]:SetSize(32, 32); 
		LabelIcon2[i]:SetPosition(widthWind - 50, positiony); 
		LabelIcon2[i]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
		--LabelIcon2:SetForeColor(Turbine.UI.Color( 1, 1, 0.7, 0 ));
		LabelIcon2[i]:SetZOrder(2);
		LabelIcon2[i]:SetMouseVisible(true);
		LabelIcon2[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		-- bleu = 0x41104EA2
		-- rouge = 0x41104EA4
		-- vert = 0x41104EA6
		-- violet = 0x41109FDE
		-- bleu clair = 0x41112617
		-- gris = 0x4111261A

		if(IsInstalled == true)then
			if(MyPlugins[i] == "OneToRuleThemAll")then
				OneToRuleThemAllWindow.Message4[i]:SetText(" " .. MyPlugins[i]);
				OneToRuleThemAllWindow.Message4[i]:SetBackColor(Turbine.UI.Color( 0.9, 0.33, 0.66, 0.33 ));
				OneToRuleThemAllWindow.Message5[i]:SetText("V" .. PluginVersion);
			else
				if(IsLoaded == true)then
					OneToRuleThemAllWindow.Message4[i]:SetText(" " .. MyPlugins[i]);
					OneToRuleThemAllWindow.Message4[i]:SetBackColor(Turbine.UI.Color( 0.9, 0.33, 0.66, 0.33 ));
					LabelIcon2[i]:SetBackground(0x41104EA6); -- vert = 0x41104EA6
					OneToRuleThemAllWindow.Message5[i]:SetText("V" .. PluginVersion);
				else
					OneToRuleThemAllWindow.Message4[i]:SetText(" " .. MyPlugins[i]);
					OneToRuleThemAllWindow.Message4[i]:SetBackColor(Turbine.UI.Color( 0.9, 0.4, 0.4, 0.4 ));
					LabelIcon2[i]:SetBackground(0x4111261A); -- gris = 0x4111261A
					OneToRuleThemAllWindow.Message5[i]:SetText("V" .. PluginVersion);
				end
			end
		else
			OneToRuleThemAllWindow.Message4[i]:SetText(" " .. MyPlugins[i]);
			LabelIcon2[i]:SetBackground(0x41104EA4); -- rouge = 0x41104EA4
			OneToRuleThemAllWindow.Message4[i]:SetBackColor(Turbine.UI.Color( 0.9, 1, 0.1, 0.1 ));
			OneToRuleThemAllWindow.Message5[i]:SetText("");
		end

		buttonVault[i] = Turbine.UI.Extensions.SimpleWindow();
		buttonVault[i]:SetParent( OneToRuleThemAllWindow );
		buttonVault[i]:SetPosition(60, positiony);
		buttonVault[i]:SetSize( 190, 30 );
		buttonVault[i]:SetMouseVisible(true);
		buttonVault[i]:SetVisible(true);
		buttonVault[i]:SetZOrder(10);
		buttonVault[i]:SetOpacity(0);
		--buttonVault[i]:SetBackColor(Turbine.UI.Color.Red)

		buttonVault[i].MouseClick = function()
			CreateAddNewWindow(MyPlugins[i], MyAdresse[i], descr[i]);
			OneToRuleThemAllAddnewWindow:SetVisible(true);
			OneToRuleThemAllWindow:SetVisible(false);
		end

		buttonVault2[i] = Turbine.UI.Extensions.SimpleWindow();
		buttonVault2[i]:SetParent( OneToRuleThemAllWindow );
		buttonVault2[i]:SetPosition(widthWind - 40, positiony);
		buttonVault2[i]:SetSize( 30, 30 );
		buttonVault2[i]:SetMouseVisible(true);
		buttonVault2[i]:SetVisible(true);
		buttonVault2[i]:SetZOrder(10);
		buttonVault2[i]:SetOpacity(0);
		--buttonVault2[i]:SetBackColor(Turbine.UI.Color.Red)

		local tmpPlugins=Turbine.PluginManager.GetLoadedPlugins();
		local pluginIndex;
		for pluginIndex=1,#tmpPlugins do
			if (tmpPlugins[pluginIndex].Name == MyPlugins[i]) then
				IsLoaded = true;
				break;
			end
		end

		buttonVault2[i].MouseClick = function(sender, args)
			if (args.Button == Turbine.UI.MouseButton.Right) then
				Turbine.PluginManager.UnloadScriptState(tostring(MyPlugins[i]));
				CreateMainWindow(300, (settings["nbrPlugins"]["nbr"] * 36) + 60);
				OneToRuleThemAllWindow:SetVisible(true);
				settings["pluginsToLoad"]["toBeLoaded" .. i] = false;
			end
			if (args.Button == Turbine.UI.MouseButton.Left) then
				Turbine.PluginManager.LoadPlugin(tostring(MyPlugins[i]));
				CreateMainWindow(300, (settings["nbrPlugins"]["nbr"] * 36) + 60);
				OneToRuleThemAllWindow:SetVisible(true);
				settings["pluginsToLoad"]["toBeLoaded" .. i] = true;
			end
		end

		positiony = positiony + 36;
	end

	EscapeKeyHandler();
	PositionChangedWindow();
end